#ifndef CLUSTER_H
#define CLUSTER_H

#include <stdbool.h>
#include <stdio.h>

#include "ds.h"

#define SMALL 1E-6
#define MAX(x, y) x > y ? x: y
#define MIN(x, y) x < y ? x : y

typedef enum 
{
  COMPLETE,
  AVERAGE,
  SINGLE
} HCLMETHOD;

/* From kmeans.c */
int intcmpr(const void*, const void*);
int dodostop(vector*, double);
int* randomcentroids(int*, int, int);
int* locateclusters(int*, int*, double*, int, int);
double chindex(int*, double*, int, int, double*, double*);
int* locatecentroids(int*, int*, double*, int, int);
double iterkmeans(double*, int*, int, int);
double kmeans(double*, int*, int, int);

/* From eigspectral.c */
void evsort(double*, double*, int, int, int);
double esclust(double*, int*, int, int, HCLMETHOD);
void writeeigvects(FILE*, double*, int, int);
double sumsq(double*, int, int, int*, int);
double* eucdist(double*, double*, int, int);
double* delrowcol(double*, int, int);
void hierclust(double*, int, int, int*, int, HCLMETHOD);
void transpose(double*, int);
static long dgeev(char, char, int, double*, int, double*, double*, double*, int, double*, int, double*, int);
int geteigvecs(double*, double*, double*, int);
int eigengap(double*, int);
double calcscales(double *, double*, int, int);
static int cmpdp(const void *, const void *);
void swaprows(double*, int, int, int);
double chindexeuc(int*, double*, int, int, int, double*, double*);

// new (just after get eigvecs)

#endif