/**
 * vector.c
 * A dynamic array data structure (vector)
 * (c) 2009 JW Leigh
 */
#include <stdlib.h>
#include "ds.h"

vector* initvector(vector *vect)
{
  vect->maxsize = INITITEMS;
  vect->size = 0;
  
  vect->items = (void**)malloc(INITITEMS * sizeof(void*));
  
  return vect;
}

void freevector(vector *vect)
{ 
  int i;
  for (i = 0; i < vect->size; i++)  free(vect->items[i]);
  free(vect->items);
}

void* getvector(vector *vect, int index)
{
  if (index > vect->size)  return NULL;
  
  return vect->items[index];
}

void* removevector(vector *vect, int index)
{
  void *item;
  if (index > vect->size)  return NULL;
  
  item = vect->items[index];
  vect->items[index] = NULL;
  vect->size--;
  
  return item;
}

void addvector(vector *vect, void *item)
{
  if (vect->size >= vect->maxsize)
  {
    vect->maxsize *= 2;
    vect->items = (void**)realloc(vect->items, vect->maxsize * sizeof(void*)); 
  }
  
  vect->items[vect->size] = item;
    
  vect->size++;
}

int sizevector(vector *vect)
{
  return vect->size;
}


